<?php

set_time_limit(0);

require_once("binary.php");
require_once("make_snes_map.php");

$arr=array(
   array( 0x1294C, 0x10000,4), // credits BG
   array( 0x5F672, 0x5EAC4,4), // NIS frame
   array( 0x747B2, 0x73C80,4), // clouds
// 0x787C0: cave sprites
   array( 0x7F7B3, 0x7E23A,4), // "copyright 1995 psygnosis presents"
// 0x80000..0x8E16A: rooms - not fully correct tiles!
   array( 0x80000, 0xB0000,4), // level 7 rooms
   array( 0x80D7B, 0xB0000,4), // level 9 rooms
   array( 0x82476, 0xB0000,4), // level 9 rooms
   array( 0x84115, 0xB0000,4), // level 9 rooms
   array( 0x85268, 0xB0000,4), // level 9 rooms
   array( 0x88000, 0xB0000,4), // level 8 rooms
   array( 0x89904, 0xB0000,4), // level 8 rooms
   array( 0x8B2DA, 0xB0000,4), // level 8 rooms
   array( 0x8C569, 0xB0000,4), // level 8 rooms
   array( 0x8E16A, 0xB0000,4), // level 8 rooms
// 0x9001E..0x96861: levels
// 0x96C2C: Prince of Persia 2
// 0x975BF: menu font
// 0x98000..0xAD7D2: rooms - not fully correct tiles!
   array( 0x98000, 0xB0000,4), // level 7 rooms
   array( 0x99A0B, 0xB0000,4), // level 7 rooms
   array( 0x9B426, 0xB0000,4), // level 7 rooms
   array( 0x9CDB7, 0xB0000,4), // level 7 rooms
   array( 0x9E1F2, 0xB0000,4), // level 7 rooms
   array( 0xA8080, 0xB0000,4), // level 6 rooms - correct tiles?
   array( 0xA9237, 0xB0000,4), // level 6 rooms
   array( 0xAA247, 0xB0000,4), // level 6 rooms
   array( 0xAA5CB, 0xB0000,4), // level 6 rooms
   array( 0xABA92, 0xB0000,4), // level 6 rooms
   array( 0xACEEF, 0xB0000,4), // level 6 rooms - incl. start room with wrong tiles!
   array( 0xAD7D2, 0xB0000,4), // level 7 rooms
// 0xDA520: ruins sprites
   array( 0xE0000, 0xE02D8,8), // NIS: ship
   array( 0xE31E5, 0xE34B7,8), // NIS: prince on ship
   array( 0xE8000, 0xE82D7,8), // NIS: come to me!
   array( 0xEC017, 0xEC2E9,8), // NIS: ship catastrophe
   array( 0xEF335, 0xEF20C,4), // password ANNOYING background
// 0x100000: desert sprites
   array(0x100DE7,0x101A2A,4), // level 2 rooms
   array(0x10C371,0x108000,4), // level 3 rooms
   array(0x10DC2C,0x108000,4), // level 3 rooms
   array(0x10F340,0x108000,4), // level 3 rooms
   array(0x110000,0x108000,4), // level 3 rooms
   array(0x1115D5,0x108000,4), // level 3 rooms
   array(0x11296A,0x108000,4), // level 3 rooms
   array(0x113CCC,0x108000,4), // level 3 rooms
   array(0x118000,0x108000,4), // level 4 rooms
   array(0x119513,0x108000,4), // level 4 rooms
   array(0x11A698,0x108000,4), // level 4 rooms
   array(0x11B87B,0x108000,4), // level 4 rooms
   array(0x11CA5A,0x108000,4), // level 4 rooms
   array(0x11DBFD,0x108000,4), // level 4 rooms
   array(0x11E94D,0x108000,4), // level 5 rooms
   array(0x120000,0x108000,4), // level 5 rooms
   array(0x1214D3,0x108000,4), // level 5 rooms
   array(0x122656,0x108000,4), // level 5 rooms
   array(0x123956,0x108000,4), // level 5 rooms
   array(0x128000,0x130380,4), // level 1 rooms (rooftops)
   array(0x129534,0x12A4A5,4), // level 1 rooms (shore)
// 0x12A1E5: rooftops BG
// 0x132AA5: rooftops BG
   array(0x133209,0x132CCA,2), // "the shadow and the flame"
   array(0x138000,0x138110,8), // "password"
   array(0x138CA9,0x138F51,8), // NIS: prince at princess
// 0x13BDED: password
   array(0x140000,0x1402B9,8), // NIS: prince in throne room
   array(0x1435E8,0x1437D1,8), // NIS: prince jumps out of window
   array(0x148000,0x1482B4,8), // NIS: after him!
   array(0x14B592,0x14B844,8), // NIS: after him! (Jaffar!)
   array(0x150000,0x1502A7,8), // NIS: don't hurt him!
   array(0x15315A,0x15341F,8), // NIS: prince and princess in window
   array(0x158000,0x158296,8), // NIS: in ancient Persia
   array(0x15B0C7,0x15B358,8), // NIS: ship catastrophe
   array(0x160100,0x1603CD,8), // NIS: princess and SOMEONE in BG
   array(0x162E7B,0x16313C,8), // NIS: princess and the fake prince in BG
   array(0x168000,0x1682AA,8), // NIS: prince at throne room door
   array(0x16AE3D,0x16B10E,8), // NIS: princess sleeping
   array(0x170000,0x1702D5,8), // NIS: princess woke up
   array(0x1738C5,0x180000,8), // NIS: the WITCH
   array(0x17559A,0x173EF3,8), // NIS: prince on horse (temple->final)
   array(0x178000,0x178696,8), // NIS: prince and princess on horse
// 0x17ED05: font
// 0x190000..0x1AE69A: rooms - not fully correct tiles!
   array(0x190000,0x1B0000,4), // level 10 rooms
   array(0x1917F4,0x1B0000,4), // level 10 rooms
   array(0x192893,0x1B0000,4), // level 10 rooms
   array(0x193D7F,0x1B0000,4), // level 10 rooms
   array(0x195908,0x1B0000,4), // level 10 rooms
   array(0x197037,0x1B0000,4), // level 10 rooms
   array(0x198000,0x1B0000,4), // level 11 rooms
   array(0x1993D7,0x1B0000,4), // level 11 rooms
   array(0x19A34E,0x1B0000,4), // level 11 rooms
   array(0x19B0CB,0x1B0000,4), // level 11 rooms
   array(0x19C53E,0x1B0000,4), // level 11 rooms
   array(0x19D873,0x1B0000,4), // level 11 rooms
   array(0x19E6C9,0x1B0000,4), // level 11 rooms
   array(0x1A0000,0x1B0000,4), // level 12 rooms
   array(0x1A1764,0x1B0000,4), // level 12 rooms
   array(0x1A2F4C,0x1B0000,4), // level 12 rooms
   array(0x1A4209,0x1B0000,4), // level 12 rooms
   array(0x1A5B0D,0x1B0000,4), // level 12 rooms
   array(0x1A6CA7,0x1B0000,4), // level 10 rooms
   array(0x1A8000,0x1B0000,4), // level 13 rooms
   array(0x1A9589,0x1B0000,4), // level 13 rooms
   array(0x1AA876,0x1B0000,4), // level 13 rooms
   array(0x1AB4E3,0x1B0000,4), // level 13 rooms
   array(0x1AC86B,0x1B0000,4), // level 13 rooms
   array(0x1AD71F,0x1B0000,4), // level 13 rooms
   array(0x1AE69A,0x1B0000,4), // level 13 rooms
// 0x1D0000: temple sprites
   array(0x1D8000,0x1D80D1,4), // "licensed by Nintendo"
   array(0x1D850D,0x1D85DB,4), // "code copyright 1995 Titus"
   array(0x1D89A9,0x1D8A77,4), // "a game by Jordan Mechner"
   array(0x1E83B6,0x1E84E3,4), // "continue yes no"
   array(0x1E8B12,0x1E8BB1,2), // circle
);

mkdir("outi");

$fn=$argv[1] or die("You must pass the name of the ROM image in the command line!");
$f=file_get_contents($fn) or die("File does not exist: \"$fn\"");
// Remove header if there is one:
switch (strlen($f) & 0x7FFF) {
	case 0: // headerless
	break;
	case 0x200: // headered
		$f=substr($f,0x200);
	break;
	default:
		die("ROM image has bad size!");
	break;
}

$pal0=""; for($i=0;$i<256;$i++) $pal0.=chr($i).chr($i).chr($i)."\x00";

foreach($arr as $l){
   list($id,$tid,/*$si,$wh,$hh,*/$bpp)=$l;
   $fn=sprintf("findalldlz/OUT_FIND_%08X",$id);
   $map=file_get_contents($fn);
   $ofn=sprintf("outi/%08X.bmp",$id);
   $fn=sprintf("findalldlz/OUT_FIND_%08X",$tid);
   if($fe=file_exists($fn)){
      $til=file_get_contents($fn);
   }else{
      $til=substr($f,$tid,0x30000);
   }
   $wh=32; $hh=strlen($map)>>6;
   make_snes_map($map,$til,$ofn,$wh,$hh,$bpp,$pal0,!$fe);
}

